       .global  __home_x,__home_y,__home_z
       .global  __home_az
; move all axis not yet home towards home at full speed until switch closes
; then switch to decel mode & stop fast
; home any remaining axis until all done
; then step out slowly until sensor clears
WAIT   EQU 200H
STEPS  EQU -32000
AZSTEP EQU  8000

home_set:
       CLR   A
       MOV   X_SIZE,A
       MOV   X_SIZE+1,A
       MOV   Y_SIZE,A
       MOV   Y_SIZE+1,A
       MOV   Z_SIZE,A
       MOV   Z_SIZE+1,A
       RET


__home_x:
		 JNB   HOME_X,HX4
HX1:
		 CALL  home_set
		 MOV   X_SIZE,# > STEPS
		 MOV   X_SIZE+1,# < STEPS
		 lcall  __xyz
HX2:
		 JB    HOME_X,HX3
		 call  KILL_STEP
		 JMP   HX4
HX3:
		 JNB   FLAG_1,HX1      ; try again
		 SJMP  HX2
HX4:                         ; get here when sensor closes
		 CLR   X_DIR           ; step out until sensor opens again
		 JB    HOME_X,HX5      ; -> HX5 when sensor opens
		 CALL  SOFT_STEP_X
		 CALL  SOFT_DELAY
		 SJMP  HX4
HX5:
		 SETB  X_DIR           ; step in until it closes
		 JNB   HOME_X,HX6
		 CALL  SOFT_STEP_X
		 CALL  SOFT_DELAY
		 SJMP  HX5
HX6:
		 RET

KILL_STEP:
       PUSH  IE
       MOV   IE,#0
       CLR   FLAG_1          ; crash halt --- see how it goes
       MOV   CV,#0
       POP   IE
       RET

__home_y:
       JNB   HOME_Y,HY4
HY1:
       CALL  home_set
       MOV   Y_SIZE,# > STEPS
       MOV   Y_SIZE+1,# < STEPS
       lcall  __xyz
HY2:
	 JB    HOME_Y,HY3
	 call  KILL_STEP
	 JMP   HY4
HY3:
       JNB   FLAG_1,HY1      ; try again
       SJMP  HY2
HY4:                         ; get here when sensor closes
       CLR   Y_DIR
       JB    HOME_Y,HY5
       CALL  SOFT_STEP_Y
       CALL  SOFT_DELAY
       SJMP  HY4
HY5:
       SETB  Y_DIR
       JNB   HOME_Y,HY6
       CALL  SOFT_STEP_Y
       CALL  SOFT_DELAY
       SJMP  HY5
HY6:
		 RET


__home_z:
       JNB   HOME_Z,HZ4
HZ1:
       CALL  home_set
       MOV   Z_SIZE,# > STEPS
       MOV   Z_SIZE+1,# < STEPS
       lcall  __xyz
HZ2:
       JB    HOME_Z,HZ3
       call  KILL_STEP
       JMP   HZ4
HZ3:
       JNB   FLAG_1,HZ1      ; try again
       SJMP  HZ2
HZ4:                         ; get here when sensor closes
       CLR   Z_DIR
       JB    HOME_Z,HZ5
       CALL  SOFT_STEP_Z
       CALL  SOFT_DELAY
       SJMP  HZ4
HZ5:
       SETB  Z_DIR
       JNB   HOME_Z,HZ6
       CALL  SOFT_STEP_Z
       CALL  SOFT_DELAY
       SJMP  HZ5
HZ6:
       RET
;
; AZ sensor is normally closed if connected
; as nasty things can happen if its not installed
; we have to be a bit careful
;
; Altered april '93 to speed it up
;
__home_az:
		 JB    HOME_AZ,HAZ6         ; exit if already open (may not be here )
HAZ1:
		 CALL  home_set
		 MOV   Z_SIZE,# >( AZSTEP)
		 MOV   Z_SIZE+1,# <( AZSTEP)
		 lcall  __xyz
HAZ2:
		 JNB    HOME_AZ,HAZ3
		 call  KILL_STEP
		 JMP   HAZ4
HAZ3:
		 JNB   FLAG_1,HAZ1      ; try again
		 SJMP  HAZ2
HAZ4:                         ; get here when sensor OPENS
		 SETB  Z_DIR
		 MOV   B,#0
		 JNB   HOME_AZ,HAZ5
		 CALL  SOFT_STEP_Z
		 CALL  SOFT_DELAY
		 DJNZ  B,HAZ4
HAZ5:
		 CLR   Z_DIR
		 MOV   B,#0
		 JB    HOME_AZ,HAZ6
		 CALL  SOFT_STEP_Z
		 CALL  SOFT_DELAY
		 DJNZ  B,HAZ5
HAZ6:
		 RET





SOFT_STEP_X:
       SETB  X_STEP
       CLR   A
       DJNZ  ACC,$
       CLR   X_STEP
       RET

SOFT_STEP_Y:
       SETB  Y_STEP
       CLR   A
       DJNZ  ACC,$
       CLR   Y_STEP
       RET

SOFT_STEP_Z:
       SETB  Z_STEP
       CLR   A
       DJNZ  ACC,$
       CLR   Z_STEP
       RET

SOFT_DELAY:
       MOV   DPTR,#-WAIT
SOFT_D1:
       INC   DPTR
       MOV   A,DPL
       ORL   A,DPH
       JNZ   SOFT_D1
       RET



