#include "c80451.h"
#include "stdio51.h"
/*
#define TESTING
*/
#ifdef TESTING
    extern near int _TESTX;
    extern near int _TESTY;
    extern near int _TESTZ;
    extern near int _CCNT;
    extern near int _CT;
    extern near char _ATX;
#endif
#define abs(x) ((x) > 0 ? (x):-(x))
void _home_x(void);
void _home_y(void);
void _home_z(void);
void _home_az(void);

void fput2xs(int,FILE_AXE);
#define CRYSTAL 11059000.0
/*
#define DEBUG
*/
#define XOFF 0x13
#define XON 0x11
unsigned char buf[100];
unsigned char ibuf[256];

static unsigned os = 35;
static unsigned oe = 5000;
static unsigned oa = 1;
static int step = 1;
extern near int _X_SIZE,_Y_SIZE,_Z_SIZE;

extern unsigned char _raw_mode;
void _flush_input_buffer(void);
int _serial_status(void);

#define RTC 0xa0
#define ENABLE_RTC 0x2d
#define SYSCON 0x40
#define NITEMS 40
void _xyz(void);
int nitems = NITEMS;
atoib(char *, int);
int xtoi(char *,int);
char * itox(int, char *, int);
void fput2x(int,FILE_AXE);
void fput2xn(int,FILE_AXE);
int clean(unsigned char *,unsigned char**,int);
int isin(char,char *);
void debout(char *);
int senses(void);    /* flags and step/direction lines */
int homes(void);     /* flags in high byte, home sensors in low */
void usage(void);
void status();
void pbin(unsigned int);
void goxyz(int,int,int);
void new_accel(unsigned int,unsigned int,unsigned int);
void wait_till_done(void);
void home(void);
void home_x(void);
void home_y(void);
void home_z(void);
void home_az(void);
void motor_on(void);
void motor_off(void);
int slong(long);

int ellipse(int,int,int);
int arc(int,int,int,int,int);
int iarc(int,int,int,int,int,int,int);

extern unsigned int _ram_tab[256],_ram_tab1[256];
void _CPY_TAB(void);   /* copy ram table 1 to ram table 0 */
void _MOV_TAB0(void);  /* copy eprom table to RAM */

void pxd();
void dout(int);
int absX,absY,absZ,relX,relY,relZ,debug;

void amove3(ax,ay,az)
int ax,ay,az;
{
	  relX = ax - absX;
	  relY = ay - absY;
	  relZ = az - absZ;
	  absX = ax;
	  absY = ay;
	  absZ = az;
	  goxyz(relX,relY,relZ);
}
void rmove3(rx,ry,rz)
int rx,ry,rz;
{
	  relX = rx;
	  relY = ry;
	  relZ = rz;
	  absX = absX + rx;
	  absY = absY + ry;
	  absZ = absZ + rz;
	  goxyz(rx,ry,rz);
}
void amove2(ax,ay)
int ax,ay;
{
	  relX = ax - absX;
	  relY = ay - absY;
	  absX = ax;
	  absY = ay;
	  goxyz(relX,relY,0);
}
void rmove2(rx,ry)
int rx,ry;
{
	  relX = rx;
	  relY = ry;
	  absX = absX + rx;
	  absY = absY + ry;
	  goxyz(relX,relY,0);
}


main()
{
int v;
int i;
char *items[NITEMS];
int rvs[NITEMS];

	 _raw_mode = 1;
	 _flush_input_buffer();
	 debug = 0;

	 fputs("\nInitiallizing",stdout);

	 new_accel(os,oe,oa);

	 fputs("\nHello World\n",stdout);

	 motor_off();

/*	 home(); */

	 while(1)
	 {
       for(i = 0 ;i< 10;i++)
       {
			rvs[i] = 0;
		 }
		 putc(XON,stdout);              /* xon */
		 if(debug == 1) fgets(&buf[0],80,stdin);
		 else fgetsne(&buf[0],80,stdin);

		 putc(XOFF,stdout);                /* xoff */
		 v = clean(&buf[0],items,nitems);
		 for(i = 1;i <= 3;i++)
		 {
			rvs[i] = atoib(items[i],10);
		 }
		 switch(*items[0])
		 {
		 case 'a':  /* arc relative, starting at top of arc */
			 arc(rvs[1],rvs[2],rvs[3],rvs[4],rvs[5]);
		 break;
		 case 'B':
			 if(rvs[1] ) motor_on();
			 else motor_off();
		 break;
		 case 'c': /* circle starting at TOP of circle */
			 ellipse(rvs[1],rvs[2],rvs[3]);
		 break;
		 case 'e': /* ellipse relative starting at TOP of ellipse */
			 ellipse(rvs[1],rvs[2],rvs[3]);
		 break;
		 case 'g': /* home Z axis using AZ switch */
			motor_off();
			_home_az();
		 break;
		 case 'f': /* Force current position to be 0,0,0 */
			  absX = 0;
			  absY = 0;
			  absZ = 0;
		 break;
		 /* home to offset position, specify x,y,z offset z_up z_down */
		 case 'h':
			  _inits();
			  _home_z();
			  _home_y();
			  _home_x();
		 break;
		 case 'L':   /* Abs move x,y*/
			 amove2(rvs[1],rvs[2]);
		 break;
		 case 'l':   /* relative move x,y */
			 rmove2(rvs[1],rvs[2]);
		 break;
		 case 'M':   /* Abs move x,y,z */
			 amove3(rvs[1],rvs[2],rvs[3]);
		 break;
		 case 'm':   /* relative move x,y,z */
			 rmove3(rvs[1],rvs[2],rvs[3]);
		 break;
		 case 'Q':
			 usage();
		 break;
		 case 'q':  /* quickness */
			  new_accel(rvs[1],rvs[2],rvs[3]);
		 break;
                 case 's':
                      if(rvs[1]) _CPY_TAB();
                      else _MOV_TAB0();
                 break;
		 case 'W':  /*  debug mode on */
			  debug = 1;
		 break;
		 case 'w':  /* debug mode off */
			  debug = 0;
		 break;
		 case 'X': /* move absolute x */
			 relX = rvs[1] - absX;
			 goxyz(relX,0,0);
			 absX = rvs[1];
		 break;
		 case 'x':  /* move relative x */
			 goxyz(rvs[1],0,0);
			 absX = absX + rvs[1];
		 break;
		 case 'Y': /* move Y absolute */
			 relY = rvs[1] - absY;
			 goxyz(0,relY,0);
			 absY = rvs[1];
		 break; /* move y relative */
		 case 'y':
			 goxyz(0,rvs[1],0);
			 absY = absY + rvs[1];
		 break;
		 case 'Z':  /* absolute Z */
			 relZ = rvs[1] - absZ;
			 goxyz(0,0,relZ);
			 absZ = rvs[1];
		 break;
		 case 'z':  /* relative Z */
			 goxyz(0,0,rvs[1]);
			 absZ = absZ + rvs[1];
		 break;
		 case '?':
				putc('X',stdout);
				putc(' ',stdout);
				dout(absX);
				putc('Y',stdout);
				putc(' ',stdout);
				dout(absY);
				putc('Z',stdout);
				putc(' ',stdout);
				dout(absZ);
				putc('\n',stdout);
		 break;
		 default:
			  putc(07,stdout);
		 break;
		 };
		 wait_till_done();
   }
}

void motor_on(void)
{
.asm
	 clr  0c8h
.endasm
}
void motor_off(void)
{
.asm
    setb   0c8h
.endasm
}
void pxd()
{
int j;
	 putc('\n',stdout);
	j = senses();
	pbin(j);
	j = homes();
	 pbin(j);
}
void wait_till_done()
{
   int j;
   do
   {
      j = senses();
   } while((j & 0x100) != 0);
   if(debug) pxd();
}


int senses()
{
.asm
    mov a,90h    ; flags
    mov r2,a
    mov a,0c8h   ; check step & direction
    mov r0,a
.endasm
}
int homes()
{
.asm
    mov a,90h    ; flags
    mov r2,a
	 mov a,0d8h   ; check home switches
	 mov r0,a
.endasm
}

void new_accel(start,end,accel)
unsigned start;
unsigned end;
unsigned accel;
{
	int i;
	float sv,ev,scaler,inc;
	unsigned k,temp;

	if(start == 0) start = os;
	if(end == 0 ) end = oe;
	if(accel == 0) accel = oa;
	sv = start;
	ev = end;
	scaler = CRYSTAL/12.0;
	k = 65535;
	inc = (ev - sv)/256.0;
	for(i = 0; i < 256; i++)
	{
		temp = scaler/sv;
		_ram_tab1[i] = (k - temp);
		sv += inc;
	}
}

void usage(void)
{
		fputsn("Valid commands are",stdout);
		fputsn("a x0 y0 x1 y1 step\tarc relative ",stdout);
		fputsn("B 0/1\t\tTurn motor Off/on",stdout);
		fputsn("c r step\t\tcircle down from current pos",stdout);
		fputsn("e rx ry step\t\tellipse down from current pos",stdout);
		fputsn("f\t\tmake current position 0,0,0",stdout);
		fputsn("g\t\tHome Z axis using AZ sensor",stdout);
		fputsn("h\t\tHome using X,Y,Z home sensors",stdout);
		fputsn("L x y\t\tmove absolute to x,y Z constant",stdout);
		fputsn("l x y\t\tmove relative x,y Z constant",stdout);
		fputsn("M x y z\t\tmove absolute to x y z",stdout);
		fputsn("m x y z\t\tmove relative x y z",stdout);
		fputsn("q s e a\t\tSet alternate speed min,max, accel (0's use current value)",stdout);
		fputsn("Q\t\tThis message",stdout);
                fputsn("s 0/1\t\tSet speed to default or alternate",stdout);
		fputsn("W\t\tdebug mode on",stdout);
		fputsn("w\t\tdebug mode off",stdout);
		fputsn("X x\t\tmove absolute to x",stdout);
		fputsn("x x\t\tmove relative x",stdout);
		fputsn("Y y\t\tmove absolute to y",stdout);
		fputsn("y y\t\tmove relative y",stdout);
		fputsn("Z z\t\tmove absolute to z",stdout);
		fputsn("z z\t\tmove relative z",stdout);
		fputsn("?\t\tPrint current X,Y,Z",stdout);
}

int clean(s,dests,n)
unsigned char *s;
unsigned char *dests[];
int n;
{
int lastwaswite;
int odex;
    lastwaswite = 1;
    odex = -1;
    while( (*s != '\0') && (odex <= n))
    {
       if(isin(*s," \t\n,:;") != 0)
       {
			 *s = '\0';
			 lastwaswite = 1;
       }
		 else
       {
			 if(lastwaswite)
          {
            odex++;
            *dests = s;
            dests++;
          }
/* UPPER CASE ROUTINE REMOVED */
/*          if( (*s >= 'a') && (*s <= 'z') ) *s = *s - ('a' - 'A'); */
          lastwaswite = 0;
        }
	s++;
     }
     if(!lastwaswite) odex++;
     return(odex);
}
void pbin(c)
unsigned int c;
{
int i;
    for( i = 0; i < 16; i++)
    {
       if( c & 0x8000 ) putc('1',stdout);
       else putc('0',stdout);
       c <<= 1;
    }

}
int isin(c,s)
char c;
char *s;
{
int res;
    res = 0;
    while(*s)
    {
        if(*s == c)
	{
              res = 1;
	      break;
         }
         s++;
    }
   return(res);
}
void fput2x(i,ch)
int i;
FILE_AXE ch;
{
    fprintf(ch,"%02x",i);
}
void fput2xs(i,ch)
int i;
FILE_AXE ch;
{
    fprintf(ch,"%02x ",i);
}
void fput2xn(i,ch)
int i;
FILE_AXE ch;
{
    fprintf(ch,"%02x\n",i);
}
/*
** atoib(s,b) - Convert s to "unsigned" integer in base b.
**              NOTE: This is a non-standard function.
*/
int atoib(s, b) char *s; int b; {
  int n, digit,sign;
  n = 0;
  sign = 1;
  if( *s == '-' )
  {
    sign = -1;
    s++;
  }
  while((digit = (127 & *s++)) >= '0')
  {
    if(digit >= 'a')      digit -= 87;
    else if(digit >= 'A') digit -= 55;
    else                  digit -= '0';
    if(digit >= b) break;
    n = b * n + digit;
  }
  return (n*sign);
}
void dout(d)
int d;
{
    int i;
    if( d < 0)
	 {
       putc('-',stdout);
       d = -d;
	 }
    i = d/10000;
	 putc( (i+0x30),stdout);
    d = d -(i*10000);
    i = d/1000;
    putc( (i+0x30),stdout);
    d = d -(i*1000);
    i = d/100;
    putc( (i+0x30),stdout);
    d = d -(i*100);
    i = d/10;
    putc( (i+0x30),stdout);
    d = d -(i*10);
    putc( (d+0x30),stdout);
}

void goxyz(x,y,z)
int x;
int y;
int z;
{
#ifdef TESTING
  int i;
#endif
  _X_SIZE = x;
  _Y_SIZE = y;
  _Z_SIZE = z;
  _xyz();
#ifdef TESTING
  wait_till_done();
  i = _TESTX;
  fprintf(stdout,"\nsteps %d",i);
  i = _TESTY;
  fprintf(stdout," %d",i);
  i = _TESTZ;
  fprintf(stdout," %d",i);
  i = _CT;
  fprintf(stdout,"Cruise %d",i);
  i = _CCNT;
  fprintf(stdout,"Start Cnt %d",i);
  i = _ATX;
  fprintf(stdout,"Acc/Dac %d",i);

#endif
}


int arc(x0,y0,x1,y1,step)
int x0,y0,x1,y1,step;
{
	iarc(absX,absY,absX+x0,absY+y0,absX+x1,absY+y1,step);
}
int ellipse(xr,yr,step)
int xr,yr,step;
{
		iarc(absX,absY,absX,absY+yr,absX+xr,absY,step)  ;
		iarc(absX,absY,absX+xr,absY,absX,absY-yr,step)  ;
		iarc(absX,absY,absX,absY-yr,absX-xr,absY,step)  ;
		iarc(absX,absY,absX-xr,absY,absX,absY+yr,step)  ;
}

long labs(long);

#define HALFPI 102944L

int iarc(cx,cy,x1,y1,x2,y2,step)
int cx,cy,x1,y1,x2,y2,step;
{
int i,x,y,prevx,prevy;
int delta_x,delta_y,delta_t,dt,den;
long vx,vy,ux,uy,l;

	prevx = prevy = -1;
	dt = 804;
	den = 10;
	l = (x1-cx);
	vx = l<<16;
	l = y1-cy;
	vy = l<<16;
	l = x2-cx;
	ux = l<<16;
	l = y2-cy;
	uy = l<<16;

	delta_x = (labs(vx) + labs(ux)) >> 16;
	delta_y = (labs(vy) + labs(uy)) >> 16;
	delta_t = delta_x + delta_y;
	while(dt > delta_t)
	{
		dt /=2;
		--den;
	}
	l = HALFPI << den;
	l = l >> 16;
	i = (int)l;
/*
	for( i = (int)((HALFPI << den ) >> 16); i >= 0; i--)
*/
	for( ; i >= 0; i--)
	{
		x =  (vx >> 16);
		y =  (vy >> 16);
		if( (abs( x - prevx) >= step) || (abs( y - prevy)>= step))
		{
			  amove2(cx+x,cy+y);
                          prevx = x;
		          prevy = y;
		}
		ux -= vx >> den;
		uy -= vy >> den;
		vx += ux >> den;
		vy += uy >> den;
	}
        if( x != x2 || y != y2)
        {
		  amove2(cx+x2,cy+y2);
        }
	return(1);
}
